﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TwelvePx.Interfaces;
using TwelvePx.Core;
using SFML.Graphics;
using SFML.Window;
using TwelvePx.Graphics;

namespace TwelvePx.Screens
{
    public class GameScreen : IScreen
    {
        public GameContext Context { get; private set; }

        public GameScreen(GameEngine Engine)
        {
            Context = new GameContext(Engine, this);
        }

        public void Update(float Delta)
        {
            Context.Update(Delta);
        }

        public void Destroy()
        {
            Context.Destroy();
        }

        public void Draw(RenderTarget target, RenderStates states)
        {
            target.Draw(Context, states);
        }

        public void OnKeyPress(KeyEventArgs Args, ref bool Handled)
        {
            Context.OnKeyPress(Args, ref Handled);
        }

        public void OnKeyRelease(KeyEventArgs Args, ref bool Handled)
        {
            Context.OnKeyRelease(Args, ref Handled);
        }

        public void OnClose(ref bool Cancel)
        {
            
        }

        public void OnResize(SizeEventArgs Args)
        {
            
        }

        public void OnFocusGain()
        {
            
        }

        public void OnFocusLose()
        {
            
        }

        public void OnTextInput(TextEventArgs Args, ref bool Handled)
        {
            
        }

        public void OnMouseMove(MouseMoveEventArgs Args, ref bool Handled)
        {
            
        }

        public void OnMouseEnter()
        {
            
        }

        public void OnMouseLeave()
        {
            
        }

        public void OnMouseButtonPress(MouseButtonEventArgs Args, ref bool Handled)
        {
            
        }

        public void OnMouseButtonRelease(MouseButtonEventArgs Args, ref bool Handled)
        {
            
        }
    }
}
